/*
 * $Id: vejotp.java,v 1.5 2004/10/02 09:00:22 veg Exp $
 * Veghead 2004 <veg@fatsquirrel.org>
 */

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.rms.*;
import java.io.*;

public class vejotp extends MIDlet 
	implements CommandListener {
	private Form mMainForm;
	private Command goCmd=new Command("Go",Command.SCREEN,0); 
	private Command backCmd=new Command("Back",Command.SCREEN,0); 
	private Command resetCmd=new Command("Reset",Command.SCREEN,0); 
	private Command saveCmd;
	private TextField itval;
	private TextField seedval;
	private TextField passval;
	private ChoiceGroup hashtype;
	private ChoiceGroup passtype;
	private ChoiceGroup savetype;
	private int hasrs,recordid;
	static final String RECORDS = "uvejotp";
	private RecordStore rs = null;
	private RecordEnumeration records = null;
	private static String hashtypes[] = {
		"MD5","MD4","SHA1"
	};
	private static String passtypes[] = {
		"English","Hex"
	};
	private static String savetypes[] = {
		"Yes","No"
	};
	private Image TitleImg;
	private Display display;
  

public vejotp() {
	mMainForm = new Form("vejotp");
	try {
		display = Display.getDisplay(this);
		if (display.isColor()) {
			TitleImg=Image.createImage("/title.png");
		} else {
			TitleImg=Image.createImage("/titlem.png");
		}
		ImageItem TitleItem=new ImageItem("",TitleImg,
				ImageItem.LAYOUT_CENTER+
				ImageItem.LAYOUT_NEWLINE_AFTER,
				"VeJOTP");
		mMainForm.append(TitleItem);
	} catch(Exception e) {
		mMainForm.append(new StringItem(null, "VeJOTP\n"));
		e.printStackTrace();
	}
	itval=new TextField("Challenge:","99",4,TextField.NUMERIC);
	seedval=new TextField("","alpha1",50,TextField.ANY);
	passval=new TextField("Passphrase:","AbCdEfGhIjK",50,
							TextField.PASSWORD);
	hashtype=new ChoiceGroup("Hash:",ChoiceGroup.EXCLUSIVE,hashtypes,null);
	passtype=new ChoiceGroup("Format:",
					ChoiceGroup.EXCLUSIVE,passtypes,null);
	savetype=new ChoiceGroup("Autosave Passphrase:",
					ChoiceGroup.EXCLUSIVE,savetypes,null);
	mMainForm.addCommand(goCmd);
	mMainForm.addCommand(resetCmd);
	mMainForm.addCommand(new Command("Exit", Command.EXIT, 0));

	// Try and open a RecordStore
	try {
		//RecordStore.deleteRecordStore(RECORDS);
		rs = RecordStore.openRecordStore(RECORDS,true);
		hasrs=1;
		saveCmd=new Command("Save All",Command.SCREEN,0); 
		mMainForm.addCommand(saveCmd);
		int numrecs=rs.getNumRecords();

		// If there's a record, get it and use the values for 
		// defaults
		if (rs.getNumRecords() > 0) {
			records=rs.enumerateRecords(null,null,false);
			recordid=records.nextRecordId();
			byte[] record = rs.getRecord(recordid);
			DataInputStream ist = 
				new DataInputStream(
					new ByteArrayInputStream(record, 0, 
						record.length));
			itval.setString(ist.readUTF());
			passval.setString(ist.readUTF());
			seedval.setString(ist.readUTF());
			hashtype.setSelectedIndex(
					Integer.parseInt(ist.readUTF()),true);
			savetype.setSelectedIndex(
					Integer.parseInt(ist.readUTF()),true);
		// Otherwise create one using defaults
		} else {
			this.resetForm();
			byte[] newrecord = this.buildRecord(true);
			rs.addRecord(newrecord, 0, newrecord.length);
		}

	} catch(Exception e) {
		hasrs=0;
		this.resetForm();
	}

	mMainForm.append(itval);
	mMainForm.append(seedval);
	mMainForm.append(new StringItem(null, "\n"));
	mMainForm.append(passval);
	mMainForm.append(hashtype);
	mMainForm.append(passtype);
	mMainForm.append(savetype);
	mMainForm.setCommandListener(this);
  }


  public void resetForm() {
	itval.setString("99");
	passval.setString("This is a test.");
	seedval.setString("TeSt");
  }


  public byte[] buildRecord(boolean savepass) {
	byte[] record=null;
	try {
		ByteArrayOutputStream bst = new ByteArrayOutputStream(12);
		DataOutputStream ost = new DataOutputStream(bst);
		ost.writeUTF(itval.getString());
		if (savepass) {
			ost.writeUTF(passval.getString());
		} else {
			ost.writeUTF("");
		}
		ost.writeUTF(seedval.getString());
		ost.writeUTF(Integer.toString(hashtype.getSelectedIndex()));
		ost.writeUTF(Integer.toString(savetype.getSelectedIndex()));
		ost.flush();
		ost.close();
		bst.toByteArray();
		record = bst.toByteArray();
	} catch(Exception e) {}
	return(record);
  }
  
  public void startApp() {
	Display.getDisplay(this).setCurrent(mMainForm);
  }
  
  public void pauseApp() {}
  
  public void destroyApp(boolean unconditional) {}
  
  public void commandAction(Command c, Displayable s) {
	if (c==goCmd) {
		Form res=new Form("OTP");
		res.append(new StringItem(null, "Password:\n\n"));
		res.addCommand(new Command("Exit", Command.EXIT, 0));
		res.addCommand(backCmd);
		int hash=5;
		boolean savepass=false;
		if (hashtype.getString(hashtype.getSelectedIndex())=="MD4") {
			hash=4;
		} else if (hashtype.getString(hashtype.getSelectedIndex())=="SHA1") {
			hash=10;
		}
		otp otpwd = new otp(Integer.parseInt(itval.getString()),
			seedval.getString(),passval.getString(),hash);
		otpwd.calc();
		if (passtype.getString(passtype.getSelectedIndex())=="Hex") {
			res.append(new StringItem(null, otpwd.toHex()));
		} else {
			res.append(new StringItem(null, otpwd.toString()));
		}
		Display.getDisplay(this).setCurrent(res);
		res.setCommandListener(this);
		int i=Integer.parseInt(itval.getString());
		if (i>1) {
			itval.setString(Integer.toString(--i));
		}
		if (savetype.getString(savetype.getSelectedIndex())=="Yes") {
			savepass=true;
		}
		try {
			byte[] record=this.buildRecord(savepass);
                	rs.setRecord(recordid,record, 0, record.length);
		} catch(Exception e) {}
	} else if (c==saveCmd) {
		try {
			byte[] record=this.buildRecord(true);
                	rs.setRecord(recordid,record, 0, record.length);
		} catch(Exception e) {}
	} else if (c==resetCmd) {
		this.resetForm();	
	} else if (c==backCmd) {
		Display.getDisplay(this).setCurrent(mMainForm);
	} else { 
		try {
			rs.closeRecordStore();
		} catch (Exception e) {}
		notifyDestroyed();
	}
  }

}
